# Define which image to run the jobs in
image: python:3

# Define the stages
stages:
  - code_quality
  - unit_testing
  - build

# Jobs definition here and onwards

pep8:
  stage: code_quality
  before_script:
    - pip install -r requirements.txt
  script:
    # Ideally, we would make the pipeline automatically fix PEP8 compliancy and
    # commit to the repo, but since that's a bit advanced for us right now, the
    # pipeline will simply abort if the code isn't PEP8 compliant.
    - autopep8 --exit-code src/main.py >/dev/null

lint:
  stage: code_quality
  before_script:
    - pip install -r requirements.txt
  script:
    - pylint src/main.py

test:
  stage: unit_testing
  before_script:
    - pip install -r requirements.txt
  script:
    - pytest --junitxml=report.xml src/
  artifacts:
    when: always
    reports:
      junit: report.xml

build:
  stage: build
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/my_image:latest -t $CI_REGISTRY_IMAGE/my_image:$CI_COMMIT_SHA .
    - docker push $CI_REGISTRY_IMAGE/my_image:latest
    - docker push $CI_REGISTRY_IMAGE/my_image:$CI_COMMIT_SHA
  rules:
    # Only run for commits and merge requests on the `main` branch
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"